.486
.model flat,stdcall
option casemap:none   ; case sensitive

; ####################################################

include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\gdi32.inc
include \masm32\include\comctl32.inc

includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\comctl32.lib

; ####################################################
IDD_DLG1  	equ 101
ID_TIMER    equ 400
SPEED	       equ 3

PictureW   equ 110
PictureH   equ 110

LEFT        equ 20 
TOP         equ 20
; ----------------------------------------------------

DlgProc  PROTO :DWORD,:UINT,:WPARAM,:LPARAM
Paint_it PROTO :DWORD,:DWORD

; ----------------------------------------------------

.data        
himage      dd offset himages

; --------------------------------------------------------------------------

.data?
hInstance   dd ?
flag        dd ?
himages     dd ?
    
; --------------------------------------------------------------------------

.code
include rgn.inc
start:

invoke GetModuleHandle,NULL
mov hInstance,eax

; -------------------------------------------
; Call the dialog box stored in resource file
; -------------------------------------------
invoke DialogBoxParam,hInstance,IDD_DLG1,0,ADDR DlgProc,0
invoke ExitProcess,0


DlgProc proc hWnd:DWORD,uMsg: UINT, wParam: WPARAM, lParam: LPARAM

LOCAL Ps:PAINTSTRUCT

.if uMsg == WM_INITDIALOG
 
mov esi,1
mov edi,offset himages
@@:
invoke LoadImage,hInstance,esi,IMAGE_BITMAP,0,0,
LR_LOADTRANSPARENT or LR_LOADMAP3DCOLORS
mov [edi], eax
add esi,1
cmp esi,5
je @F
add edi,4
jmp @B  
@@:                       

invoke SetTimer,hWnd,ID_TIMER,SPEED,NULL
invoke SetFocus,hWnd

.elseif uMsg == WM_COMMAND
.elseif uMsg == WM_LBUTTONDOWN
	invoke SendMessage, hWnd, WM_NCLBUTTONDOWN,HTCAPTION, 0

.elseif uMsg == WM_NOTIFY

.elseif uMsg == WM_PAINT
invoke BeginPaint,hWnd,ADDR Ps
invoke EndPaint,hWnd,ADDR Ps

.elseif uMsg == WM_CLOSE || uMsg == WM_RBUTTONUP

invoke KillTimer,hWnd,ID_TIMER
invoke EndDialog,hWnd,NULL

.elseif uMsg == WM_TIMER

inc flag
cmp flag,5
jne @F
mov flag,0
mov himage,offset himages
 
@@:
mov esi,himage
lodsd
invoke Paint_it,hWnd,eax
add himage,4

.endif
xor eax,eax
ret

DlgProc endp

Paint_it proc hWnd:DWORD, hImage:DWORD

LOCAL hDC:DWORD
LOCAL hMemDC:DWORD

invoke GetDC,hWnd
mov hDC,eax
invoke CreateCompatibleDC,hDC
mov hMemDC,eax
invoke SelectObject,hMemDC,hImage
invoke BitBlt,hDC,LEFT,TOP,PictureW,PictureH,hMemDC,0,0,SRCCOPY
invoke DeleteDC,hMemDC
invoke ReleaseDC,hWnd,hDC
ret

Paint_it endp
end start