.486
.model flat,stdcall
option casemap:none   ; case sensitive

; ####################################################

include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\gdi32.inc
include \masm32\include\comctl32.inc

includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\comctl32.lib



.const
; ####################################################
IDD_DLG1  	equ 101
ID_TIMER    equ 400
SPEED	      equ 3

PictureW   equ 110
PictureH   equ 110

; ----------------------------------------------------

DlgProc  PROTO :DWORD,:UINT,:WPARAM,:LPARAM
Paint_it PROTO :DWORD,:DWORD

; ----------------------------------------------------

.data        
himage      dd offset himages

; --------------------------------------------------------------------------

.data?
hInstance   dd ?
flag        dd ?
himages     dd ?

; --------------------------------------------------------------------------

.code
include rgn.inc
start:

invoke GetModuleHandle,NULL
mov hInstance,eax

; -------------------------------------------
; Call the dialog box stored in resource file
; -------------------------------------------
invoke DialogBoxParam,hInstance,IDD_DLG1,0,ADDR DlgProc,0
invoke ExitProcess,0


DlgProc proc hWnd:DWORD,uMsg: UINT, wParam: WPARAM, lParam: LPARAM

LOCAL ps:PAINTSTRUCT

mov  eax,uMsg
.if eax == WM_INITDIALOG
 
mov esi,1
mov edi,offset himages
@@:
invoke LoadImage,hInstance,esi,IMAGE_BITMAP,0,0,
LR_LOADTRANSPARENT or LR_LOADMAP3DCOLORS
mov [edi], eax
add esi,1
cmp esi,5
je @F
add edi,4
jmp @B  
@@:                       

invoke SetTimer,hWnd,ID_TIMER,SPEED,NULL


.elseif  eax == WM_COMMAND
    mov  edx,wParam
movzx eax,dx
shr edx,16
.elseif eax == WM_LBUTTONDOWN
invoke SendMessage, hWnd, WM_NCLBUTTONDOWN,HTCAPTION, 0

.elseif  eax == WM_NOTIFY

.elseif  eax == WM_PAINT

; WM_ERASEBKGND is needed to Suppress the split second background erase at the start of window [Thanks jj2007]
.elseif  eax == WM_ERASEBKGND
xor eax, eax
inc eax
ret

.elseif eax == WM_CLOSE || eax == WM_RBUTTONUP

invoke KillTimer,hWnd,ID_TIMER
invoke EndDialog,hWnd,NULL

.elseif eax == WM_TIMER

inc flag
cmp flag,5
jne @F
mov flag,0
mov himage,offset himages
 
@@:
mov edx,himage
invoke Paint_it,hWnd,[edx]
add himage,4

.endif
xor eax,eax
ret

DlgProc endp

Paint_it proc hWnd:DWORD, hImage:DWORD

LOCAL hDC:DWORD
LOCAL hMemDC:DWORD
LOCAL myDC:HDC
LOCAL rect:RECT   


invoke GetDC,hWnd
mov hDC,eax

invoke CreateCompatibleDC,hDC
mov hMemDC,eax

invoke SelectObject,hMemDC,hImage
invoke GetWindowRect,hWnd,addr rect
invoke GetClientRect,hWnd,addr rect
	mov eax,hMemDC
	mov myDC,eax
	push PictureW
	push PictureH
	push hMemDC 
	call MakeRegion
	invoke SetWindowRgn,hWnd,eax,TRUE

invoke BitBlt,hDC,0,0,rect.right,rect.bottom,hMemDC,0,0,SRCCOPY
invoke DeleteDC,hMemDC
invoke ReleaseDC,hWnd,hDC
ret

Paint_it endp
end start